import com.imptt.proptt.pttserver.plugins.V4.*;
import java.sql.*;

public class PTTPlugin4Sample implements IPTTPlugin4
{
	ICallback4 cbObject = null;
	public int getInterfaceVersion()
	{
		System.out.println("PTTPlugin4Sample::getInterfaceVersion");
		return INTERFACE_VERSION;
	}
	
	public int getType()
	{
		System.out.println("PTTPlugin4Sample::getType");
		return TYPE_GENERAL_PLUGIN;
	}
	
	public void setCallback(ICallback4 cbObject)
	{
		System.out.println("PTTPlugin4Sample::setCallback cbObject="+cbObject);
		this.cbObject = cbObject;
	}
	
	public boolean initialize(String arg)
	{
		System.out.println("PTTPlugin4Sample::initialize arg="+arg);
		Connection conn = cbObject.getDBConnection();
		if(conn != null)
		{
			int dbSchemaVersion = 0;
			Statement stmt = null;
			try 
			{
				stmt = conn.createStatement();
				String sqlStr = "SELECT TextValue FROM TB_Setup WHERE TextKey='db.schema.version'";
				ResultSet rs = stmt.executeQuery(sqlStr);
				if(rs.next())
				{
					dbSchemaVersion = rs.getInt(1);
				}
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
			}
			if ( stmt != null ) try { stmt.close(); }catch (Exception e){}
			System.out.println("PTTPlugin4Sample::initialize dbSchemaVersion="+dbSchemaVersion);
		}
		if(cbObject!=null) cbObject.OnInitialized();
		return true;
	}
	

	//events
	public void OnConnected(String userId, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnConnected userId="+userId+", jsonParams="+jsonParams);
	}
	
	public void OnJoined(String userId, int channelId)
	{
		System.out.println("PTTPlugin4Sample::OnJoined userId="+userId+", channelId="+channelId);
	}
	
	public void OnLocked(String userId, int channelId, int lockIndex, int mediaProfileId, String userLocation, String audioCodec, String videoCodec, String encKey, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnLocked userId="+userId+", channelId="+channelId+", jsonParams="+jsonParams);
	}

	public void OnPTT(int channelId, int lockIndex, byte[] frames)
	{
		System.out.println("PTTPlugin4Sample::OnPTT channelId="+channelId+", frames.length="+frames.length);
	}

	public void OnUnLocked(String userId, int channelId, int lockIndex)
	{
		System.out.println("PTTPlugin4Sample::OnUnlocked userId="+userId+", channelId="+channelId);
	}
	
	public void OnVideoShare(String userId, int channelId, int videoChannelId, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnVideoShare userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId+", jsonParams="+jsonParams);
	}

	public void OnVideoShared(String userId, int channelId, int videoChannelId)
	{
		System.out.println("PTTPlugin4Sample::OnVideoShared userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId);
	}

	public void OnVideoUnshare(String userId, int channelId, int videoChannelId, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnVideoUnshare userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId+", jsonParams="+jsonParams);
	}

	public void OnVideoUnshared(String userId, int channelId, int videoChannelId)
	{
		System.out.println("PTTPlugin4Sample::OnVideoUnshared userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId);
	}
	
	public void OnFileShare(String userId, int channelId, int fileChannelId, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnFileShare userId="+userId+", channelId="+channelId+", fileChannelId="+fileChannelId+", jsonParams="+jsonParams);
	}

	public void OnFileShared(String userId, int channelId, int fileChannelId)
	{
		System.out.println("PTTPlugin4Sample::OnFileShared userId="+userId+", channelId="+channelId+", fileChannelId="+fileChannelId);
	}

	public void OnFileUnshare(String userId, int channelId, int fileChannelId, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnFileUnshare userId="+userId+", channelId="+channelId+", fileChannelId="+fileChannelId+", jsonParams="+jsonParams);
	}

	public void OnFileUnshared(String userId, int channelId, int fileChannelId)
	{
		System.out.println("PTTPlugin4Sample::OnFileUnshared userId="+userId+", channelId="+channelId+", fileChannelId="+fileChannelId);
	}

	public void OnText(String userId, int channelId, int messageId, String base64Message)
	{
		System.out.println("PTTPlugin4Sample::OnText userId="+userId+", channelId="+channelId+", messageId="+messageId+", base64Message="+base64Message);
	}
	
	public void OnCustomMessage(String userId, int channelId, int messageId, String base64Message)
	{
		System.out.println("PTTPlugin4Sample::OnCustomMessage userId="+userId+", channelId="+channelId+", messageId="+messageId+", base64Message="+base64Message);
	}
	
	public void OnFunction(String userId, int channelId, String latitude, String longitude, String functionName, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnFunction userId="+userId+", channelId="+channelId+", functionName="+functionName+", jsonParams="+jsonParams);
	}
	
	public void OnLocation(String userId, String latitude, String longitude)
	{
		System.out.println("PTTPlugin4Sample::OnLocation userId="+userId+", latitude="+latitude+", longitude="+longitude);
	}
	
	public void OnLeaved(String userId, int channelId)
	{
		System.out.println("PTTPlugin4Sample::OnLeaved userId="+userId+", channelId="+channelId);
	}
	
	public void OnDisconnected(String userId)
	{
		System.out.println("PTTPlugin4Sample::OnDisconnected userId="+userId);
	}

	public void OnClientDirectMessage(String userId, String message)
	{
		System.out.println("PTTPlugin4Sample::OnClientDirectMessage userId="+userId+", message="+message);
	}

	public void OnError(int errCode, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnError errCode="+errCode+", jsonParams="+jsonParams);
	}
	
	public void OnExtenedEvent(String cmdName, String jsonParams)
	{
		System.out.println("PTTPlugin4Sample::OnExtenedEvent cmdName="+cmdName+", jsonParams="+jsonParams);
	}
	
}
